# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "ais"


def test_decode_result(self):
    worklist = self.decode(
        """H|\\^&|||PU32|||||||P||20100804141023
P|1|Ex US ANA Xt|||BOND^JAMES^M||19851201|M
O|1|BIO2010-32RAD^^PtRack1^3||^^^dsDNA|R|20100804135712|20080130083000|||||||||||||||||BPX1|
R|1|^^^dsDNA^QUANT|1|IU/mL||<||F|||20100804141004|20100804141015
R|2|^^^dsDNA^QUAL|Negative|||||F|||20100804141004|20100804141015
L|1|N"""
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "type": "patient",
                "sample_id": "BIO2010-32RAD",
                "rack": "PtRack1-3",
                "results": [
                    {
                        "code": "dsDNAQUANT",
                        "value": "1",
                        "date": datetime.datetime(2010, 8, 4, 14, 10, 15),
                        "flags": ["<"],
                        "instrument": "BPX1",
                    },
                    {
                        "code": "dsDNAQUAL",
                        "value": "Negative",
                        "date": datetime.datetime(2010, 8, 4, 14, 10, 15),
                        "flags": [],
                        "instrument": "BPX1",
                    },
                ],
            }
        ],
    }
    assert worklist == expected


def test_order(self):
    message = self.order()
    expected = """H|\\^&|||MCA|||||||P||20130715141912
        P|1|036666666|||NYME^ANO||20110513|F
        O|1|123456||^^^A\\^^^B|S||20130603110342||||||||||||||||||O
        L|1"""
    assert message == expected
