# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "byg_astm"


def test_encode_order(self):
    message = self.order()
    expected = """
    H|\\^&|||MCA|||||EVM||P|1|20130715141912
    P|1|036666666|||NYME^ANO||20110513|F|||||||||||||||||^^LOC
    O|1|123456||^^^A\\^^^B|R|20130603110342|||||N||||||||||||||O
    R|1|^^^A|42|||||N||||20110506121400
    R|2|^^^B|201302131516|||||N||||20110506121300
    O|2|123456||^^^C|R|20130603110342|||||C||||||||||||||O
    L|1|F
    """
    assert message == expected


def test_decode_result(self):
    worklist = self.decode(
        """
        H|\\^&|||EVM |||||LIS ||P|1|201410151610
        P|1|01130213121|||TEST^ANONYME||19510115|M
        O|1|03104||^^^11140|R||||||||||||||||||||F
        R|1|^^^111401^^^^F|A|||||F||||20141015121000
        L|1|N
        """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "type": "patient",
                "sample_id": "03104",
                "results": [
                    {
                        "value": "A",
                        "code": "111401",
                        "date": datetime.datetime(2014, 10, 15, 12, 10, 00),
                        "comments": [],
                    }
                ],
            }
        ],
    }
    assert worklist == expected
